# Custom properties data

The following endpoints allow you to manage custom scenario properties data.

To use custom properties, you have to:

1. Create a custom properties structure.
2. Create custom properties structure items.
3. Fill the items with data.

Read more about custom properties in the [custom properties feature documentation](https://help.make.com/custom-scenario-properties).

## Get custom properties data

> Gets custom properties data of the specified scenario.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Scenarios / Custom properties data","description":"The following endpoints allow you to manage custom scenario properties data.\n\nTo use custom properties, you have to:\n\n1. [Create a custom properties structure](../../custom-properties/post--custom-property-structures.md).\n2. [Create custom properties structure items](../../custom-properties/structure-items/post--custom-property-structures--custompropertystructureid--custom-property-structure-items.md).\n3. [Fill the items with data](./post--scenarios--scenarioid--custom-properties.md).\n\nRead more about custom properties in the [custom properties feature documentation](https://help.make.com/custom-scenario-properties).\n"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["scenarios:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/scenarios/{scenarioId}/custom-properties":{"get":{"tags":["Scenarios / Custom properties data"],"summary":"Get custom properties data","description":"Gets custom properties data of the specified scenario.","parameters":[{"name":"scenarioId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the scenario."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"customProperties":{"type":"object"},"scenarioId":{"type":"number"}}}}}}}}}}}
```

## Fill in custom properties data

> Fills in custom properties data for the specified scenario. The scenario has to have no custom properties data.\
> \
> The data you fill in has to conform to the current custom scenario properties structure. You have to specify a value for every required item, otherwise you get an error.\
> \
> To update existing data, use the following API calls:\
> \
> \- \[Update custom properties data]\(./patch--scenarios--scenarioid--custom-properties.md)\
> \- \[Set custom properties data]\(./put--scenarios--scenarioid--custom-properties.md)<br>

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Scenarios / Custom properties data","description":"The following endpoints allow you to manage custom scenario properties data.\n\nTo use custom properties, you have to:\n\n1. [Create a custom properties structure](../../custom-properties/post--custom-property-structures.md).\n2. [Create custom properties structure items](../../custom-properties/structure-items/post--custom-property-structures--custompropertystructureid--custom-property-structure-items.md).\n3. [Fill the items with data](./post--scenarios--scenarioid--custom-properties.md).\n\nRead more about custom properties in the [custom properties feature documentation](https://help.make.com/custom-scenario-properties).\n"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["scenarios:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/scenarios/{scenarioId}/custom-properties":{"post":{"tags":["Scenarios / Custom properties data"],"summary":"Fill in custom properties data","description":"Fills in custom properties data for the specified scenario. The scenario has to have no custom properties data.\n\nThe data you fill in has to conform to the current custom scenario properties structure. You have to specify a value for every required item, otherwise you get an error.\n\nTo update existing data, use the following API calls:\n\n- [Update custom properties data](./patch--scenarios--scenarioid--custom-properties.md)\n- [Set custom properties data](./put--scenarios--scenarioid--custom-properties.md)\n","parameters":[{"name":"scenarioId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the scenario."}],"requestBody":{"content":{"application/json":{"schema":{"type":"object"}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"customProperties":{"type":"object"},"scenarioId":{"type":"number"}}}}}}}}}}}
```

## Set custom properties

> Sets custom properties data for the specified scenario. Make replaces the original data with the data you send in the request body.\
> \
> You have to specify a value for every required custom properties structure item, otherwise you get an error.\
> \
> The scenario has to have custom property data already. The new data set has to conform to the current custom scenario properties structure. If the initial data is empty, then the API call returns an error.\
> \
> To fill in first values to the custom properties, use the API call to \[fill in custom properties data]\(./post--scenarios--scenarioid--custom-properties.md).<br>

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Scenarios / Custom properties data","description":"The following endpoints allow you to manage custom scenario properties data.\n\nTo use custom properties, you have to:\n\n1. [Create a custom properties structure](../../custom-properties/post--custom-property-structures.md).\n2. [Create custom properties structure items](../../custom-properties/structure-items/post--custom-property-structures--custompropertystructureid--custom-property-structure-items.md).\n3. [Fill the items with data](./post--scenarios--scenarioid--custom-properties.md).\n\nRead more about custom properties in the [custom properties feature documentation](https://help.make.com/custom-scenario-properties).\n"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["scenarios:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/scenarios/{scenarioId}/custom-properties":{"put":{"tags":["Scenarios / Custom properties data"],"summary":"Set custom properties","description":"Sets custom properties data for the specified scenario. Make replaces the original data with the data you send in the request body.\n\nYou have to specify a value for every required custom properties structure item, otherwise you get an error.\n\nThe scenario has to have custom property data already. The new data set has to conform to the current custom scenario properties structure. If the initial data is empty, then the API call returns an error.\n\nTo fill in first values to the custom properties, use the API call to [fill in custom properties data](./post--scenarios--scenarioid--custom-properties.md).\n","parameters":[{"name":"scenarioId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the scenario."}],"requestBody":{"content":{"application/json":{"schema":{"type":"object"}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"customProperties":{"type":"object"},"scenarioId":{"type":"number"}}}}}}}}}}}
```

## Delete custom properties data

> Deletes custom properties data.\
> Deleting custom properties data is irreversible.\
> Use the \`confirmed\` parameter to confirm deleting the data, otherwise you get an error and the data are not deleted.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Scenarios / Custom properties data","description":"The following endpoints allow you to manage custom scenario properties data.\n\nTo use custom properties, you have to:\n\n1. [Create a custom properties structure](../../custom-properties/post--custom-property-structures.md).\n2. [Create custom properties structure items](../../custom-properties/structure-items/post--custom-property-structures--custompropertystructureid--custom-property-structure-items.md).\n3. [Fill the items with data](./post--scenarios--scenarioid--custom-properties.md).\n\nRead more about custom properties in the [custom properties feature documentation](https://help.make.com/custom-scenario-properties).\n"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["scenarios:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/scenarios/{scenarioId}/custom-properties":{"delete":{"tags":["Scenarios / Custom properties data"],"summary":"Delete custom properties data","description":"Deletes custom properties data.\nDeleting custom properties data is irreversible.\nUse the `confirmed` parameter to confirm deleting the data, otherwise you get an error and the data are not deleted.","parameters":[{"name":"scenarioId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the scenario."},{"name":"confirmed","in":"query","schema":{"type":"boolean"}}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"ok":{"type":"integer"}}}}}}}}}}}
```

## Update custom properties data

> Updates custom properties data of the specified scenario. Make updates only the custom properties data you specify in the request body.\
> \
> The custom property has to contain data already. The update data have to conform to the current custom scenario properties structure. If the initial value is empty, then the API call returns an error.\
> \
> To fill in first values to the custom properties, use the API call to \[fill in custom properties data]\(./post--scenarios--scenarioid--custom-properties.md).<br>

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Scenarios / Custom properties data","description":"The following endpoints allow you to manage custom scenario properties data.\n\nTo use custom properties, you have to:\n\n1. [Create a custom properties structure](../../custom-properties/post--custom-property-structures.md).\n2. [Create custom properties structure items](../../custom-properties/structure-items/post--custom-property-structures--custompropertystructureid--custom-property-structure-items.md).\n3. [Fill the items with data](./post--scenarios--scenarioid--custom-properties.md).\n\nRead more about custom properties in the [custom properties feature documentation](https://help.make.com/custom-scenario-properties).\n"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["scenarios:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/scenarios/{scenarioId}/custom-properties":{"patch":{"tags":["Scenarios / Custom properties data"],"summary":"Update custom properties data","description":"Updates custom properties data of the specified scenario. Make updates only the custom properties data you specify in the request body.\n\nThe custom property has to contain data already. The update data have to conform to the current custom scenario properties structure. If the initial value is empty, then the API call returns an error.\n\nTo fill in first values to the custom properties, use the API call to [fill in custom properties data](./post--scenarios--scenarioid--custom-properties.md).\n","parameters":[{"name":"scenarioId","in":"path","schema":{"type":"integer"},"required":true,"description":"The ID of the scenario."}],"requestBody":{"content":{"application/json":{"schema":{"type":"object"}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"customProperties":{"type":"object"},"scenarioId":{"type":"number"}}}}}}}}}}}
```
